      program inversion
c
c     Simulated annealing with ramgeo1.5 engine
c
      include 'common.h'

      common /INVPARS/nf,ksqw,alpw,udat,nter,mter,temp0,nsamp,iseed
      common /ENVPARS/nl,npar,nbath,tabsorb,f(mpar),df(mpar),
     >     fmin(mpar),fmax(mpar),ifree(mpar)
      common /RAMPARS/np,nz,ns,rs,rp,dz,dr,omega,k0,c0,zs,rmin,rmax,
     >     nrec,ir(mrec),dir(mrec),idata
      common /CONSTANTS/pi,ci,eta,eps

      real ksqw(mz),alpw(mz),alpb(mz),eval(mpar),evec(mpar,mpar),
     >     ev(mpar),f0(mpar),x0(mpar),fold(mpar),rhob(mz),rb(mr),
     >     zb(mr),TIMEARY(2),fbest(mpar)
      real function DTIME

      complex ci,udat(mz),ksqb(mz),urep(mz)

      open(unit=1,status='old',file='f_grad.in')
      open(unit=3,status='unknown',file='ffp_inv.out')
      open(unit=31,status='unknown',file='ffp_inv_prm.out')

      call setup

      do i=1,nf
         ii=ifree(i)
         df(ii)=0.5*(fmax(ii)-fmin(ii))
      enddo

      write(*,*)' '
      write(*,*)'   enter ireg (=0 rot. c.,=1 for unrot. c., =2',
     >  'for no c.)'
      write(*,*)' '
      read(*,*)ireg

c     read in the eigenvectors.

      if(ireg.eq.0)then
         nf2=nf
         open(unit=2,status='old',file='sa_eig.out')
         do i=1,nf
            read(2,*)idum,eval(i)
            write(*,*)' '
            write(*,*)i,eval(i)
c     
            vnrm=0.0
            do j=1,nf
               read(2,*)jdum,evec(i,j)
               vnrm=vnrm+evec(i,j)**2
            enddo
            vnrm=sqrt(vnrm)
c     
            write(*,*)'   i,eval ',i,eval(i)
            do j=1,nf
               evec(i,j)=evec(i,j)/vnrm
               write(*,*)j,evec(i,j)*df(j)
            enddo
c     
         enddo

         close(2)

         else if (ireg.eq.1)then
            nf2=nf
            do i=1,nf
               do j=1,nf
                  evec(i,j)=0.0
                  if(i.eq.j)evec(i,j)=1.0
               enddo
               do j=1,nf
                  write(*,*)j,evec(i,j)*df(j)
               enddo
c     
            enddo
         else if (ireg.eq.2)then
            nf2=1

            do i=1,nf
               do j=1,nf
                  evec(i,j)=0.0
                  if(i.eq.j)evec(i,j)=1.0
               enddo
               do j=1,nf
                  write(*,*)j,evec(i,j)*df(j)
               enddo
c     
            enddo
         else
            print*,'Illegal ireg. Stopping.'
            stop
         endif
c
c     randomly select a point in the parameter space.
c
c      call srand(iseed)

      do  j=1,nf
         jj=ifree(j)
         f0(jj)=f(jj)
         x0(jj)=0.5*(fmin(jj)+fmax(jj))
c         f(jj)=fmin(jj)+(fmax(jj)-fmin(jj))*rand(0)
         f(jj)=fmin(jj)+(fmax(jj)-fmin(jj))*ran(iseed)
      enddo
c
      call parmtr(rhob,ksqb,alpb,rb,zb)
      call ram(urep,rhob,ksqw,ksqb,alpw,alpb,rb,zb)

      call energy(urep,udat,mz,nrec,e)
c
      ebest=e
      iter=0
      write(*,*)' '
      write(*,*)' '
      write(*,*)iter,iter,e
      write(*,*)(f(ifree(j)),j=1,nf)
c
c     the simulated annealing loop.
c
      temp=temp0
      den=0.0
      top=0.0
      do iter=1,nter
c 
c     the eigenvector perturbations.
c
         do i=1,nf2
            den=den+1.0
            olde=e
c            xran=(-1.0+2.0*rand(0))**3
            xran=(-1.0+2.0*ran(iseed))**3
c
            do j=1,nf
               jj=ifree(j)
               fold(jj)=f(jj)
               if(ireg.le.1)then
                  f(jj)=f(jj)+df(jj)*evec(i,j)*xran
               else
                  f(jj)=f(jj)+df(jj)*xran
                  xran=(-1.0+2.0*ran(iseed))**3
               endif
               if(f(jj).lt.fmin(jj))f(jj)=2.0*fmin(jj)-f(jj)
               if(f(jj).gt.fmax(jj))f(jj)=2.0*fmax(jj)-f(jj)
            enddo

            call parmtr(rhob,ksqb,alpb,rb,zb)
            call ram(urep,rhob,ksqw,ksqb,alpw,alpb,rb,zb)

            call energy(urep,udat,mz,nrec,e)
            de=e-olde
            arg=amin1(60.0,de/temp)
c            xran=rand(0)*exp(arg)
            xran=ran(iseed)*exp(arg)
c     
c     reject perturbation if xran > 1

            if(iter.gt.mter)xran=1.0+de
            if(xran.gt.1.0)then
               e=olde
               top=top+1.0
               do j=1,nf
                  jj=ifree(j)
                  f(jj)=fold(jj)
               enddo
            end if
c
            if(e.lt.ebest)then
               write(*,*)'   **** new best energy ****'
               ebest=e
               do j=1,nf
                  jj=ifree(j)
                  fbest(j)=f(jj)
               enddo
	       open(unit=21,file='best.dat',form='formatted',
     &		    status='unknown')
	       write(21,*)iter,i,e
	       write(21,*)(f(ifree(j)),j=1,nf)
	       close(21)

            end if
c
            write(*,*)'  acceptance ratio ',(den-top)/den
            write(*,*)iter,i,e
            write(*,*)(f(ifree(j)),j=1,nf)
         enddo
c
         temp=temp0/float(iter)
c
         write(3,*)iter,e
         write(31,*)iter,e
         write(31,*)(f(ifree(j)),j=1,nf)

c
c     compute the ev coefficients.
c
         do i=1,nf
            ev(i)=0.0
            do j=1,nf
               jj=ifree(j)
               ev(i)=ev(i)+evec(i,j)*(f(jj)-x0(jj))/df(jj)
            enddo
         enddo
         write(3,*)(ev(i),i=1,nf)
c
      enddo

	close(3)
	close(31)

      do i=1,nf
         ii=ifree(i)
         f(ii)=fbest(i)
      enddo

C*ltf*      call parmtr(rhob,ksqb,alpb,rb,zb)
C*ltf*      call ram(urep,rhob,ksqw,ksqb,alpw,alpb,rb,zb)
C*ltf*      call energy(urep,udat,mz,nrec,e)
      print*,'Best energy',ebest
      print*,'Best parameters',(f(ifree(j)),j=1,nf)

c     Write out field amplitude to file
      open(unit=10,status='unknown',file='rep.out')
      open(unit=11,status='unknown',file='amp.out')
      do i=1,nrec
         write(10,*)real(urep(i)),imag(urep(i))
         write(11,*)cabs(udat(i)),cabs(urep(i))
      enddo
      close(10)
      close(11)
c
c     the exact values.
c
      open(unit=4,status='unknown',file='ffp_inv.dat')
      do i=1,nf
         ev(i)=0.0
         do j=1,nf
            jj=ifree(j)
            ev(i)=ev(i)+evec(i,j)*(f0(jj)-x0(jj))/df(jj)
         enddo
         write(4,*)ev(i)
      enddo

      TIME=DTIME(TIMEARY)
      print*,''
      print*,'-------------------------------------'
      PRINT*,'TIMES (S):',TIME,TIMEARY(1),TIMEARY(2)

      stop
      end
