      program landscape
c
c     Compute gradients of parameter landscape with ramgeo1.5 engine
c
      include 'common.h'

      common /INVPARS/nf,ksqw,alpw,udat,nter,mter,temp0,nsamp,iseed
      common /ENVPARS/nl,npar,nbath,tabsorb,f(mpar),df(mpar),
     >     fmin(mpar),fmax(mpar),ifree(mpar)
      common /RAMPARS/np,nz,ns,rs,rp,dz,dr,omega,k0,c0,zs,rmin,rmax,
     >     nrec,ir(mrec),dir(mrec),idata
      common /CONSTANTS/pi,ci,eta,eps

      real cov(mpar,mpar),ksqw(mz),alpw(mz),alpb(mz),grad(mpar),
     >     rhob(mz),rb(mr),zb(mr)
      complex ci,udat(mz),ksqb(mz),urep(mz)
CLTF
      real TIMEARY(2)
      real function DTIME
CLTF
      open(unit=1,status='old',file='f_grad.in')
      open(unit=2,status='unknown',file='sa_eig.out')

      call setup

      do i=1,nf
         do j=1,nf
            cov(i,j)=0.0
         enddo
      enddo


c      call srand(iseed)
      do isamp=1,nsamp

c     randomly select a point in the parameter space.

         do j=1,nf
            jj=ifree(j)
c            f(j)=fmin(jj)+(fmax(jj)-fmin(jj))*rand(0)
            f(jj)=fmin(jj)+(fmax(jj)-fmin(jj))*ran(iseed)
         enddo


         call parmtr(rhob,ksqb,alpb,rb,zb)
         call ram(urep,rhob,ksqw,ksqb,alpw,alpb,rb,zb)

         call energy(urep,udat,mz,nrec,e)

c     compute the gradients

         do j=1,nf
            jj=ifree(j)
            f(jj)=f(jj)+df(jj)
            call parmtr(rhob,ksqb,alpb,rb,zb)
            call ram(urep,rhob,ksqw,ksqb,alpw,alpb,rb,zb)

            call energy(urep,udat,mz,nrec,e2)
            grad(j)=0.5*(fmax(jj)-fmin(jj))*(e2-e)/df(jj)
            write(*,*)isamp,j,f(jj)-df(jj),grad(j)
            f(jj)=f(jj)-df(jj)
         enddo

         do i=1,nf
            do j=1,nf
               cov(i,j)=cov(i,j)+grad(i)*grad(j)
            enddo
         enddo

      enddo

      trace=0.0
      do j=1,nf
         trace=trace+cov(j,j)
      enddo

      do i=1,nf
         do j=1,nf
            cov(i,j)=cov(i,j)/trace
         enddo
      enddo

      call sa_eig(cov,nf)

      TIME=DTIME(TIMEARY)
      print*,''
      print*,'-------------------------------------'
      PRINT*,'TIMES (S):',TIME,TIMEARY(1),TIMEARY(2)



      stop
      end
