      subroutine ram(u,rhob,ksqw,ksqb,alpw,alpb,rb,zb)

      include 'common.h'


      common /RAMPARS/np,nz,ns,rs,rp,dz,dr,omega,k0,c0,zs,rmin,rmax,
     >     nrec,ir(mrec),dir(mrec),idata
      common /CONSTANTS/pi,ci,eta,eps

      real k0,ksqw,rb(mr),zb(mr)
      complex ci,ksq,ksqb,u,v,r1,r2,r3,s1,s2,s3,pd1,pd2,ur,urange

      dimension rhob(mz),alpw(mz),alpb(mz),f1(mz),f2(mz),f3(mz),ksq(mz),
     >     ksqw(mz),ksqb(mz),u(mz),v(mz),r1(mz,mp),r2(mz,mp),r3(mz,mp),
     >     s1(mz,mp),s2(mz,mp),s3(mz,mp),pd1(mp),pd2(mp),urange(mz)

c     counting for horizontal array
      irangemin=rmin/dr
      irangemax=rmax/dr
      irange=1
      icount=0

      ib=1
      r=dr
      z=zb(1)
      iz=1.0+z/dz
      iz=max(2,iz)
      iz=min(nz,iz)
      if(rs.lt.dr)rs=2.0*rmax

      do j=1,mp
         r3(1,j)=0.0
         r1(nz+2,j)=0.0
      enddo
      do i=1,nz+2
         u(i)=0.0
         v(i)=0.0
      enddo
c
c     The initial starting field.
c
      call selfs(mz,nz,mp,np,ns,iz,zs,dr,dz,pi,c0,k0,rhob,alpw,alpb,
     >   ksq,ksqw,ksqb,f1,f2,f3,u,v,r1,r2,r3,s1,s2,s3,pd1,pd2)

      if(irange.ge.irangemin)then
         icount=icount+1
         urange(icount)=((1.0-dir(1))*f3(ir(1))*u(ir(1))+
     >        dir(1)*f3(ir(1)+1)*u(ir(1)+1))
      endif

c
c     The propagation matrices.
c
      call epade(mp,np,ns,1,k0,c0,dr,pd1,pd2)
      call matrc(mz,nz,mp,np,iz,iz,dz,k0,rhob,alpw,alpb,ksq,ksqw,ksqb,
     >   f1,f2,f3,r1,r2,r3,s1,s2,s3,pd1,pd2)

c
c     March the acoustic field out in range.
c
    1 call updat(mr,mz,nz,mp,np,iz,ib,dr,dz,eta,omega,rmax,c0,k0,ci,r,
     >   rp,rs,rb,zb,cw,cb,rhob,attn,alpw,alpb,ksq,ksqw,ksqb,f1,f2,f3,
     >   r1,r2,r3,s1,s2,s3,pd1,pd2)


      call solve(mz,nz,mp,np,iz,u,v,r1,r2,r3,s1,s2,s3)

      r=r+dr

      irange=irange+1
      if(irange.ge.irangemin)then
         icount=icount+1
         urange(icount)=((1.0-dir(1))*f3(ir(1))*u(ir(1))+
     >        dir(1)*f3(ir(1)+1)*u(ir(1)+1))
      endif

      if(r.lt.rmax)go to 1



      if(idata.lt.2)then
c     vertical array case
c     compute pressure
         do i=1,iz
            u(i)=u(i)*f3(i)
         enddo
         call normalize(mr,mz,nrec,ir,dir,u)
      else
c     horizontal array case
         amp2=0.0
         do i=1,nrec
            u(i)=cabs(urange(i))
            amp2=amp2+u(i)**2
         enddo
         amp2=sqrt(1.0/amp2)
         do i=1,nrec
            u(i)=u(i)*amp2
         enddo
      endif

      return
      end

