      subroutine setup

      include 'common.h'

      common /INVPARS/nf,ksqw,alpw,udat,nter,mter,temp0,nsamp,iseed
      common /ENVPARS/nl,npar,nbath,tabsorb,f(mpar),df(mpar),
     >     fmin(mpar),fmax(mpar),ifree(mpar)
      common /RAMPARS/np,nz,ns,rs,rp,dz,dr,omega,k0,c0,zs,rmin,rmax,
     >     nrec,ir(mrec),dir(mrec),idata
      common /CONSTANTS/pi,ci,eta,eps
      
      real k0,rhob(mz),ksqw(mz),alpw(mz),alpb(mz),cw(mz),
     >     rb(mr),zb(mr)
      complex ci,udat(mz),ksqb(mz)
      
c
      read(1,*)
      read(1,*)nter,mter,temp0
      read(1,*)nsamp,iseed,idata
      read(1,*)freq,zs,nrec,dzrec,zrec
      read(1,*)rmin,rmax,dr
      read(1,*)zmax,dz,tabsorb
      read(1,*)c0,np,ns,rs
      read(1,*)nl,nbath

c     constants
      pi=4.0*atan(1.0)
      ci=cmplx(0.0,1.0)
      eta=1.0/(40.0*pi*alog10(exp(1.0)))
      eps=1.0e-20

      omega=2.0*pi*freq
      k0=omega/c0
      nz=ifix(zmax/dz-0.5)
      rp=2.0*rmax

      if(nz+2.gt.mz)then
         write(*,*)'   Need to increase parameter mz to ',nz+2
         stop
      end if
      if(np.gt.mp)then
         write(*,*)'   Need to increase parameter mp to ',np
         stop
      end if
      if(nbath.gt.mr)then
         write(*,*)'   Need to increase parameter mr to ',nbath
         stop
      end if

c     read water column ssp
      call zread(mz,nz,dz,cw)
      do i=1,nz+2
         ksqw(i)=(omega/cw(i))**2-k0**2
         alpw(i)=sqrt(cw(i)/c0)
      enddo

c     read in bathymetry and layer parameters
      i=1
      nf=0
 1    read(1,*)idum,f(i),df(i),fmin(i),fmax(i)
      if(idum.lt.0)goto 2
      if(df(i).gt.0.0)then
         nf=nf+1
         ifree(nf)=i
      endif
      i=i+1
      goto 1
 2    npar=i-1


      write(*,*)'Bathymetry points :',nbath
      write(*,*)'r , z'
      write(*,*)'-----------------------------'
      do i=1,nbath
         write(*,*)f(2*i-1),f(2*i)
      enddo
      write(*,*)

      write(*,*)'Sediment parameters :',npar-2*nbath
      write(*,*)

c     receiver depths
      do j=1,nrec
         ri=1.0+zrec/dz
         ir(j)=ifix(ri)
         dir(j)=ri-float(ir(j))
         zrec=zrec+dzrec
      enddo

c     compute synthetic data or read data file

      if(idata.eq.0)then
         write(*,*)"Computing Synthetic Vertical array Data"

         call parmtr(rhob,ksqb,alpb,rb,zb)
         call ram(udat,rhob,ksqw,ksqb,alpw,alpb,rb,zb)
      else if (idata.eq.1)then

         write(*,*)"Reading Vertical Array Data from File"
         open(unit=13,status='old',file='pressure.dat')
         umag=0.0
         do i=1,nrec
            read(13,*)udatr,udati
            udat(i)=cmplx(udatr,udati)
            umag=umag+cabs(udat(i))**2
         enddo
         close(13)

c     normalize
         umag=1.0/sqrt(umag)
         do i=1,nrec
            udat(i)=udat(i)*umag
         enddo

         else if(idata.eq.2) then
            nrec=1+(rmax-rmin)/dr
            write(*,*)'Computing synthetic horizontal array data',nrec
         call parmtr(rhob,ksqb,alpb,rb,zb)
         call ram(udat,rhob,ksqw,ksqb,alpw,alpb,rb,zb)

         else if(idata.eq.3) then
            nrec=1+(rmax-rmin)/dr
            write(*,*)"Reading Horizontal Array Data from File ",nrec
            open(unit=13,status='old',file='pressure.dat')
            umag=0.0
            r=rmin
c     remove cylindrical spreading and normalize
            do i=1,nrec
               read(13,*)udatr,udati
               udat(i)=cabs(cmplx(udatr,udati)*sqrt(r))
               umag=umag+cabs(udat(i))**2
               r=r+dr
            enddo
            close(13)

            umag=1.0/sqrt(umag)
            do i=1,nrec
               udat(i)=udat(i)*umag
            enddo
         endif

      return
      end
