      subroutine parmtr(rhob,ksqb,alpb,rb,zb)


      include 'common.h'

      common /ENVPARS/nl,npar,nbath,tabsorb,f(mpar),df(mpar),
     >     fmin(mpar),fmax(mpar),ifree(mpar)
      common /RAMPARS/np,nz,ns,rs,rp,dz,dr,omega,k0,c0,zs,rmin,rmax,
     >     nrec,ir(mrec),dir(mrec),idata
      common /CONSTANTS/pi,ci,eta,eps

      real cb(mz),rhob(mz),attn(mz),ksqw(mz),alpw(mz),
     >     alpb(mz),k0,rb(mr),zb(mr)
      complex ci,ksqb(mz)

      freqkHz=omega/(2000.0*pi)

c     bathymetry

      do i=1,nbath
         rb(i)=f(2*i-1)
         zb(i)=f(2*i)
      enddo
      rb(nbath+1)=2.0*rmax
      zb(nbath+1)=zb(nbath)


c     sediment parameters
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Layer Parameterization for Layer i (for i < nl) 
c     f((i-1)*4+2*nbath+1)= layer thickness
c     f((i-1)*4+2*nbath+2)= cp_top
c     f((i-1)*4+2*nbath+3)= rho_top
c     f((i-1)*4+2*nbath+4)= attn_top
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     Layer Parmeterization for Basement 
c     f((nl-1)*4+2*nbath+1)= cp_basement
c     f((nl-1)*4+2*nbath+2)= rho_basement
c     f((nl-1)*4+2*nbath+3)= attn_basement
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c     Input units: c (m/s), rho (gm/cm^3), attn (dB/(m KHz))
c     dB/lambda = attn*c/1000.0
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     number of parameters per layer
      nppl=4

      itop=1
      j=2*nbath
      do i=1,nl-2
         ibot=itop+ifix(0.5+f(j+1)/dz)-1
         do ii=itop,ibot
            cb(ii)=f(j+2)+(f(j+2+nppl)-f(j+2))*
     >           (ii-itop)/(ibot-itop+1)
            rhob(ii)=f(j+3)+(f(j+3+nppl)-f(j+3))*
     >           (ii-itop)/(ibot-itop+1)
            attn(ii)=f(j+4)+(f(j+4+nppl)-f(j+4))*
     >           (ii-itop)/(ibot-itop+1)
         enddo
         j=j+nppl
         itop=ibot+1
      enddo

      ibot=itop+ifix(0.5+f(j+1)/dz)-1
      do ii=itop,ibot
         cb(ii)=f(j+2)+(f(j+2+nppl-1)-f(j+2))*
     >        (ii-itop)/(ibot-itop+1)
         rhob(ii)=f(j+3)+(f(j+3+nppl-1)-f(j+3))*
     >        (ii-itop)/(ibot-itop+1)
         attn(ii)=f(j+4)+(f(j+4+nppl-1)-f(j+4))*
     >        (ii-itop)/(ibot-itop+1)
      enddo
      j=j+nppl
      itop=ibot+1

c     half space

      ibot=nz+2-ifix(0.5+tabsorb/dz)-1
      do i=itop,ibot
         cb(i)=f(j+1)
         rhob(i)=f(j+2)
         attn(i)=f(j+3)
      enddo

c     absorbing layer

      itop=ibot+1
      do i=itop,nz+2
         cb(i)=f(j+1)
         rhob(i)=f(j+2)
         attn(i)=f(j+3)+(10.0-f(j+3))*(i-itop)/(nz+2-itop)
      enddo

    1 do 2 i=1,nz+2
         ksqb(i)=((omega/cb(i))*(1.0+ci*eta*attn(i)*
     >        cb(i)*.001))**2-k0**2
C*Note: Above stmt assumes input units of dB/(m KHz)
C* If input units are dB/lambda, then use the
C* following statement instead of above:
C         ksqb(i)=((omega/cb(i))*(1.0+ci*eta*attn(i)))**2-k0**2
         alpb(i)=sqrt(rhob(i)*cb(i)/c0)
c         write(98,*)(i-1)*dz,cb(i),rhob(i),attn(i)
    2 continue

      return
      end
